// Inport from...
// ---------------------------
// MineSweeper for Windows CUI
// Author:Imoimo
// Maked At:2010/08/29
// ---------------------------

#include <nds.h>

#include <stdio.h>
#include <stdlib.h>

#include "_console.h"
#include "_consolewritelog.h"
#include "maindef.h"
#include "memtool.h"
#include "_const.h"
#include "inifile.h"

#include "glib.h"
#include "rect.h"
#include "strtool.h"

#include "sndeff.h"
extern void StartSE(EWAVFN WAVFN);

#include "fat2.h"
#include "shell.h"
#include "procstate.h"

#include "skinpack.h"

#include "libms.h"
#include "Particle.h"

static EGameMode GameMode;

static u32 Level;
static u32 ElapsedTime;

static bool EnableSE;

static void StartSE(EWAVFN WAVFN)
{
  if(EnableSE==true) SoundSE_Start(WAVFN);
}

enum ECellCheck {ECC_Frame,ECC_None,ECC_Flag,ECC_Mark};

typedef struct {
  bool ReqDraw;
  u32 Hint;
  bool isOpened;
  ECellCheck Check;
  bool isBomb;
  bool isPreview;
} TCell;
static s32 CellsWidth,CellsHeight;
static TCell *pCells;

static u32 BombsCount;
static bool BombsSetupped;

static int HitBombsCount;
static int RemainFlagsCount;

static CglCanvas *pTopBM,*pBtmBM;
static CglB15 *pTopBG;

static CglTGF *pInfoBarTGF;

static TPoint ScrPos;

static u32 RestBomb;

static void MS_SetFlag(s32 x,s32 y);

static bool InsideCellFromPos(u32 x,u32 y)
{
  if((CellsWidth<=x)||(CellsHeight<=y)) return(false);
  return(true);
}

static inline TCell* GetCellFromPos(u32 x,u32 y)
{
//  if((CellsWidth<=x)||(CellsHeight<=y)) StopFatalError(0,"Index error. (%d<=%d)||(%d<=%d)",CellsWidth,x,CellsHeight,y);
  return(&pCells[(y*CellsWidth)+x]);
}

// -----------------------------------------------

static s32 CellSizeTop,CellSizeBtm;

// -----------------------------------------------

typedef struct {
  s32 CellSize;
  CglB15 *pBG;
  CglB15 *pFrame;
  CglTGF *pBomb;
  CglB15 *pClose;
  CglB15 *pFlag;
  CglTGF *pHint[9];
  CglB15 *pMark;
} TCellImgs;

static TCellImgs CellImgsTop,CellImgsBtm;

static void CellImgs_Init(TCellImgs *pci)
{
  pci->CellSize=0;
  
#define Init(c) c=NULL;

  Init(pci->pBG);
  Init(pci->pFrame);
  Init(pci->pBomb);
  Init(pci->pClose);
  Init(pci->pFlag);
  for(u32 idx=0;idx<9;idx++){
    Init(pci->pHint[idx]);
  }
  Init(pci->pMark);
  
#undef Init
}

static void CellImgs_Load(TCellImgs *pci,s32 CellSize)
{
  pci->CellSize=CellSize;
  
#define GetESF(fn8,fn12,fn16,fn20,fn24,fn32) { \
  switch(CellSize){ \
    case 8: ESF=fn8; break; \
    case 12: ESF=fn12; break; \
    case 16: ESF=fn16; break; \
    case 20: ESF=fn20; break; \
    case 24: ESF=fn24; break; \
    case 32: ESF=fn32; break; \
  } \
}
  
  ESkinFiles ESF=(ESkinFiles)-1;
  
  GetESF(ESF_Cell8_BG_b15,ESF_Cell12_BG_b15,ESF_Cell16_BG_b15,ESF_Cell20_BG_b15,ESF_Cell24_BG_b15,ESF_Cell32_BG_b15);
  pci->pBG=SkinPack_LoadB15(ESF);
  GetESF(ESF_Cell8_Frame_b15,ESF_Cell12_Frame_b15,ESF_Cell16_Frame_b15,ESF_Cell20_Frame_b15,ESF_Cell24_Frame_b15,ESF_Cell32_Frame_b15);
  pci->pFrame=SkinPack_LoadB15(ESF);
  GetESF(ESF_Cell8_Bomb_tgf,ESF_Cell12_Bomb_tgf,ESF_Cell16_Bomb_tgf,ESF_Cell20_Bomb_tgf,ESF_Cell24_Bomb_tgf,ESF_Cell32_Bomb_tgf);
  pci->pBomb=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Close_b15,ESF_Cell12_Close_b15,ESF_Cell16_Close_b15,ESF_Cell20_Close_b15,ESF_Cell24_Close_b15,ESF_Cell32_Close_b15);
  pci->pClose=SkinPack_LoadB15(ESF);
  GetESF(ESF_Cell8_Flag_b15,ESF_Cell12_Flag_b15,ESF_Cell16_Flag_b15,ESF_Cell20_Flag_b15,ESF_Cell24_Flag_b15,ESF_Cell32_Flag_b15);
  pci->pFlag=SkinPack_LoadB15(ESF);
  GetESF(ESF_Cell8_Hint0_tgf,ESF_Cell12_Hint0_tgf,ESF_Cell16_Hint0_tgf,ESF_Cell20_Hint0_tgf,ESF_Cell24_Hint0_tgf,ESF_Cell32_Hint0_tgf);
  pci->pHint[0]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint1_tgf,ESF_Cell12_Hint1_tgf,ESF_Cell16_Hint1_tgf,ESF_Cell20_Hint1_tgf,ESF_Cell24_Hint1_tgf,ESF_Cell32_Hint1_tgf);
  pci->pHint[1]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint2_tgf,ESF_Cell12_Hint2_tgf,ESF_Cell16_Hint2_tgf,ESF_Cell20_Hint2_tgf,ESF_Cell24_Hint2_tgf,ESF_Cell32_Hint2_tgf);
  pci->pHint[2]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint3_tgf,ESF_Cell12_Hint3_tgf,ESF_Cell16_Hint3_tgf,ESF_Cell20_Hint3_tgf,ESF_Cell24_Hint3_tgf,ESF_Cell32_Hint3_tgf);
  pci->pHint[3]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint4_tgf,ESF_Cell12_Hint4_tgf,ESF_Cell16_Hint4_tgf,ESF_Cell20_Hint4_tgf,ESF_Cell24_Hint4_tgf,ESF_Cell32_Hint4_tgf);
  pci->pHint[4]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint5_tgf,ESF_Cell12_Hint5_tgf,ESF_Cell16_Hint5_tgf,ESF_Cell20_Hint5_tgf,ESF_Cell24_Hint5_tgf,ESF_Cell32_Hint5_tgf);
  pci->pHint[5]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint6_tgf,ESF_Cell12_Hint6_tgf,ESF_Cell16_Hint6_tgf,ESF_Cell20_Hint6_tgf,ESF_Cell24_Hint6_tgf,ESF_Cell32_Hint6_tgf);
  pci->pHint[6]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint7_tgf,ESF_Cell12_Hint7_tgf,ESF_Cell16_Hint7_tgf,ESF_Cell20_Hint7_tgf,ESF_Cell24_Hint7_tgf,ESF_Cell32_Hint7_tgf);
  pci->pHint[7]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Hint8_tgf,ESF_Cell12_Hint8_tgf,ESF_Cell16_Hint8_tgf,ESF_Cell20_Hint8_tgf,ESF_Cell24_Hint8_tgf,ESF_Cell32_Hint8_tgf);
  pci->pHint[8]=SkinPack_LoadTGF(ESF);
  GetESF(ESF_Cell8_Mark_b15,ESF_Cell12_Mark_b15,ESF_Cell16_Mark_b15,ESF_Cell20_Mark_b15,ESF_Cell24_Mark_b15,ESF_Cell32_Mark_b15);
  pci->pMark=SkinPack_LoadB15(ESF);
  
#undef GetESF
}

static void CellImgs_Free(TCellImgs *pci)
{
  pci->CellSize=0;
  
#define DelFree(c) { \
  if(c!=NULL){ \
    delete c; c=NULL; \
  } \
}

  DelFree(pci->pBG);
  DelFree(pci->pFrame);
  DelFree(pci->pBomb);
  DelFree(pci->pClose);
  DelFree(pci->pFlag);
  for(u32 idx=0;idx<9;idx++){
    DelFree(pci->pHint[idx]);
  }
  DelFree(pci->pMark);
  
#undef DelFree
}

// -----------------------------------------------

static int rand(int max)
{
  int ret=rand()/((double)RAND_MAX+1)*max;
  return(ret);
}

static bool GetBombsSetupped(void)
{
  return(BombsSetupped);
}

static __attribute__ ((noinline)) void SetupBomb(s32 curx,s32 cury)
{
  if(BombsSetupped==true) return;
  BombsSetupped=true;
  
  for(u32 idx=0;idx<BombsCount;idx++){
    while(1){
      s32 bx=rand(CellsWidth),by=rand(CellsHeight);
      if(((curx-1)<=bx)&&(bx<=(curx+1))&&((cury-1)<=by)&&(by<=(cury+1))) continue;
      TCell *pCell=GetCellFromPos(bx,by);
      if(pCell->isBomb==true) continue;
      if(pCell->Check!=ECC_None) continue;
      pCell->ReqDraw=true;
      pCell->isBomb=true;
      
      for(s32 x=-1;x<=1;x++){
        for(s32 y=-1;y<=1;y++){
          s32 tagx=bx+x,tagy=by+y;
          if((0<=tagx)&&(tagx<CellsWidth)&&(0<=tagy)&&(tagy<CellsHeight)){
            TCell *pCell=GetCellFromPos(tagx,tagy);
            pCell->ReqDraw=true;
            pCell->Hint++;
          }
        }
      }
      break;
    }
  }
}

// -----------------------------------------------

static u32 AutoOpenFlagsChecked;
static u32 *pAutoOpenFlags;
static u32 AutoOpenFlagsLevel;

static u32 AutoOpenSEInterval;

static inline const u32* GetAutoOpenFlagsPointerFromPos(u32 y)
{
  if(CellsHeight<=y) StopFatalError(0,"Index error. (%d<=%d)",CellsHeight,y);
  return(&pAutoOpenFlags[y*CellsWidth]);
}

static inline u32 GetAutoOpenFlagFromPos(u32 x,u32 y)
{
  if((CellsWidth<=x)||(CellsHeight<=y)) StopFatalError(0,"Index error. (%d<=%d)||(%d<=%d)",CellsWidth,x,CellsHeight,y);
  return(pAutoOpenFlags[(y*CellsWidth)+x]);
}

static inline void SetAutoOpenFlagFromPos(u32 x,u32 y,u32 Value)
{
  if((CellsWidth<=x)||(CellsHeight<=y)) StopFatalError(0,"Index error. (%d<=%d)||(%d<=%d)",CellsWidth,x,CellsHeight,y);
  pAutoOpenFlags[(y*CellsWidth)+x]=Value;
}

static void AutoOpen_Init(void)
{
  pAutoOpenFlags=(u32*)safemalloc(&MM_Process,MS_CellsMaxWidth*MS_CellsMaxHeight*sizeof(u32));
  AutoOpenFlagsChecked=true;
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      SetAutoOpenFlagFromPos(x,y,0);
    }
  }
  AutoOpenFlagsLevel=0;
}

static void AutoOpen_Free(void)
{
  if(pAutoOpenFlags!=NULL){
    safefree(&MM_Process,pAutoOpenFlags); pAutoOpenFlags=NULL;
  }
}

static void Cells_AutoOpen_ins(const s32 posx,const s32 posy)
{
  for(s32 vx=-1;vx<=1;vx++){
    for(s32 vy=-1;vy<=1;vy++){
      if((vx!=0)||(vy!=0)){
        const s32 tagx=posx+vx,tagy=posy+vy;
        if((0<=tagx)&&(tagx<CellsWidth)&&(0<=tagy)&&(tagy<CellsHeight)){
          TCell *pCell=GetCellFromPos(tagx,tagy);
          if((pCell->Check==ECC_None)&&(pCell->isOpened==false)){
            pCell->ReqDraw=true;
            pCell->isOpened=true;
            if(pCell->Hint==0){
              SetAutoOpenFlagFromPos(tagx,tagy,AutoOpenFlagsLevel);
              AutoOpenFlagsLevel++;
            }
            const s32 CellSize=CellSizeBtm;
            Particle_SetFire((tagx*CellSize)+(CellSize/2)-ScrPos.x,(tagy*CellSize)+(CellSize/2)-ScrPos.y);
          }
        }
      }
    }
  }
}

void Cells_AutoOpen(const TPoint pos)
{
  AutoOpenFlagsChecked=false;
  
  TCell *pCell=GetCellFromPos(pos.x,pos.y);
  if(pCell->Hint!=0) return;
  
  AutoOpenSEInterval=1;
  
  AutoOpenFlagsLevel=1;
  
  SetAutoOpenFlagFromPos(pos.x,pos.y,AutoOpenFlagsLevel);
  AutoOpenFlagsLevel++;
  
  for(u32 idx=0;idx<2;idx++){
    const s32 CellSize=CellSizeBtm;
    Particle_SetFire((pos.x*CellSize)+(CellSize/2)-ScrPos.x,(pos.y*CellSize)+(CellSize/2)-ScrPos.y);
  }
}

bool MS_ProcessAutoOpen(void)
{
  u32 cnt=AutoOpenFlagsLevel/16;
  if(cnt==0) cnt=1;
  
  bool StartSE_AutoOpen=false;
  
  while(1){
    if(cnt==0) break;
    cnt--;
    
    u32 min=0;
    u32 tagx=0,tagy=0;
    for(u32 y=0;y<CellsHeight;y++){
      const u32 *pAutoOpenFlags=GetAutoOpenFlagsPointerFromPos(y);
      for(u32 x=0;x<CellsWidth;x++){
        u32 Level=pAutoOpenFlags[x];
        if(Level!=0){
          if(min==0){
            min=Level;
            tagx=x; tagy=y;
            }else{
            if(Level<min){
              min=Level;
              tagx=x; tagy=y;
            }
          }
        }
      }
    }
    if(min==0){
      if(AutoOpenFlagsChecked==false){
        AutoOpenFlagsChecked=true;
        bool StartSE_AutoFlag=false;
        for(s32 y=1;y<CellsHeight-1;y++){
          for(s32 x=1;x<CellsWidth-1;x++){
            TCell *pCell=GetCellFromPos(x,y);
            if((pCell->isBomb==true)&&(pCell->isOpened==false)&&(pCell->Check==ECC_None)){
              bool Opened=true;
              for(s32 py=y-1;py<=y+1;py++){
                for(s32 px=x-1;px<=x+1;px++){
                  if((y!=py)||(x!=px)){
                    TCell *pCell=GetCellFromPos(px,py);
                    if(pCell->isOpened==false) Opened=false;
                  }
                }
              }
              if(Opened==true){
                StartSE_AutoFlag=true;
                MS_SetFlag(x,y);
              }
            }
          }
        }
        {
          bool FullOpened=true;
          for(u32 y=0;y<CellsHeight;y++){
            for(u32 x=0;x<CellsWidth;x++){
              TCell *pCell=GetCellFromPos(x,y);
              if(pCell->isBomb==false){
                if(pCell->isOpened==false) FullOpened=false;
              }
            }
          }
          if(FullOpened==true){
            StartSE_AutoFlag=false;
            for(u32 y=0;y<CellsHeight;y++){
              for(u32 x=0;x<CellsWidth;x++){
                TCell *pCell=GetCellFromPos(x,y);
                if(pCell->isBomb==true){
                  if(pCell->Check!=ECC_Flag){
                    const s32 CellSize=CellSizeBtm;
                    Particle_SetFireAutoFlag((x*CellSize)+(CellSize/2)-ScrPos.x,(y*CellSize)+(CellSize/2)-ScrPos.y);
                    MS_SetFlag(x,y);
                  }
                }
              }
            }
          }
        }
        if(StartSE_AutoFlag==true) StartSE(WAVFN_AutoFlag);
      }
      return(false);
    }
    
    StartSE_AutoOpen=true;
    SetAutoOpenFlagFromPos(tagx,tagy,0);
    Cells_AutoOpen_ins(tagx,tagy);
  }
  
  if(StartSE_AutoOpen==true){
    if(AutoOpenSEInterval==0){
      AutoOpenSEInterval=2;
      StartSE(WAVFN_AutoOpen);
      }else{
      AutoOpenSEInterval--;
    }
  }
  
  return(true);
}

// -----------------------------------------------

static void ChangeCellSizeBtm(u32 CellSize)
{
  CellImgs_Free(&CellImgsBtm);
  
  _consolePrintf("Change cell size to %d pixels.\n",CellSize);
  
if(0){
  while(1){
    if(CellSize==MS_CellMaxSize) break;
    const s32 cs2=CellSize*2;
    if((ScreenWidth<=((CellsWidth*CellSize)+cs2))&&(ScreenHeight<=((CellsHeight*CellSize)+cs2))) break;
    CellSize+=4;
    if(CellSize==28) CellSize+=4;
    _consolePrintf("Resize to %d pixels.\n",CellSize);
  }
}
  
  while(1){
    if(CellSize==MS_CellMinSize) break;
    u32 size=CellsWidth*CellSize*CellsHeight*CellSize*2;
    _consolePrintf("Request VRAM %dkb.\n",size/1024);
    if(size<(1*1024*1024)) break;
    CellSize-=4;
    if(CellSize==28) CellSize-=4;
    _consolePrintf("Resize to %d pixels.\n",CellSize);
  }
  
  CellSizeBtm=CellSize;
  CellImgs_Load(&CellImgsBtm,CellSize);
  
  PrintFreeMem_Accuracy();
  
  if(pBtmBM!=NULL){
    delete pBtmBM; pBtmBM=NULL;
  }
  pBtmBM=new CglCanvas(&MM_Process,NULL,CellsWidth*CellSize,CellsHeight*CellSize,pf15bit);
  
  ScrPos.x=0;
  ScrPos.y=0;
  ScrPos=MS_InsideScreen(ScrPos);
  
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      pCell->ReqDraw=true;
    }
  }
}

// -----------------------------------------------

void MS_Init(u32 _Level,s32 _CellsWidth,s32 _CellsHeight,u32 _BombsCount,bool GameMain,u32 _CellSizeBtm)
{
  GameMode=EGM_Play;
  
  EnableSE=true;
  
  Level=_Level;
  
  ElapsedTime=0;
  
  CellsWidth=_CellsWidth;
  CellsHeight=_CellsHeight;
  
  pCells=(TCell*)safemalloc(&MM_Process,MS_CellsMaxWidth*MS_CellsMaxHeight*sizeof(TCell));
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      pCell->ReqDraw=true;
      ECellCheck ECC=ECC_None;
      if((x==0)||(x==(CellsWidth-1))) ECC=ECC_Frame;
      if((y==0)||(y==(CellsHeight-1))) ECC=ECC_Frame;
      pCell->Check=ECC;
      pCell->Hint=0;
      pCell->isOpened=false;
      if(ECC==ECC_Frame) pCell->isOpened=true;
      pCell->isBomb=false;
      pCell->isPreview=false;
    }
  }
  
  AutoOpen_Init();
  
  {
    CellImgs_Init(&CellImgsTop);
    
    CellSizeTop=MS_CellMaxSize;
    while(1){
      if(((CellsWidth*CellSizeTop)<=ScreenWidth)&&((CellsHeight*CellSizeTop)<=ScreenHeight)) break;
      CellSizeTop-=4;
      if(CellSizeTop==28) CellSizeTop-=4;
    }
    CellImgs_Load(&CellImgsTop,CellSizeTop);
    
    pTopBG=SkinPack_LoadB15(ESF_GameMainTopBG_b15);
//    if(GameMain==false) pTopBG->pCanvas->FillFull(RGB15(31,31,31)|BIT15);
    
    pTopBM=new CglCanvas(&MM_Process,NULL,ScreenWidth,ScreenHeight,pf15bit);
    
    if((pTopBM->GetWidth()!=pTopBG->GetWidth())||(pTopBM->GetHeight()!=pTopBG->GetHeight())){
      _consolePrintf("TopBM/TopBG size error. %d!=%d or %d!=%d.\n",pTopBM->GetWidth(),pTopBG->GetWidth(),pTopBM->GetHeight(),pTopBG->GetHeight());
      while(1);
    }
    
    pTopBG->pCanvas->BitBltFullBeta(pTopBM);
    
    pInfoBarTGF=SkinPack_LoadTGF(ESF_GameMainInfoBar_tgf);
    
    _consolePrintf("Loaded images for top screen.\n");
  }
  
  {
    CellImgs_Init(&CellImgsBtm);
    CellSizeBtm=0;
    pBtmBM=NULL;
    if(GameMain==true) ChangeCellSizeBtm(_CellSizeBtm);
  }
  
  BombsCount=_BombsCount;
  BombsSetupped=false;
  
  HitBombsCount=0;
  RemainFlagsCount=BombsCount;
  
  RestBomb=0;
}

void MS_Free(void)
{
  CellImgs_Free(&CellImgsTop);
  CellImgs_Free(&CellImgsBtm);
  
  if(pCells!=NULL){
    safefree(&MM_Process,pCells); pCells=NULL;
  }
  
  AutoOpen_Free();
  
  if(pTopBG!=NULL){
    delete pTopBG; pTopBG=NULL;
  }
  if(pTopBM!=NULL){
    delete pTopBM; pTopBM=NULL;
  }
  if(pInfoBarTGF!=NULL){
    delete pInfoBarTGF; pInfoBarTGF=NULL;
  }

  if(pBtmBM!=NULL){
    delete pBtmBM; pBtmBM=NULL;
  }
}

void MS_Interrupt(void)
{
  GameMode=EGM_Interrupt;
}

void MS_VsyncInterrupt(u32 VsyncCount)
{
  if(BombsSetupped==false) return;
  if(GameMode!=EGM_Play) return;
  
  ElapsedTime+=VsyncCount;
}

void MS_SetupDemo(void)
{
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if(pCell->Check==ECC_None){
        if(BombsCount==0){
          pCell->isOpened=true;
          }else{
          BombsCount--;
          pCell->isBomb=true;
          pCell->Check=ECC_Flag;
        }
      }
    }
  }
}

void MS_SetEnableSE(bool _EnableSE)
{
  EnableSE=_EnableSE;
}

// -----------------------------------------------

u32 MS_GetCellsWidth(void)
{
  return(CellsWidth);
}

u32 MS_GetCellsHeight(void)
{
  return(CellsHeight);
}

EGameMode MS_GetGameMode(void)
{
  return(GameMode);
}

// -----------------------------------------------

static void MS_Refresh_ins(CglCanvas *pcan,const TCellImgs *pci,const bool isTop)
{
  const u32 CellSize=pci->CellSize;
  const u32 PadX=(pcan->GetWidth()-(CellsWidth*CellSize))/2;
  const u32 PadY=(pcan->GetHeight()-(CellsHeight*CellSize))/2;
  
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if(pCell->ReqDraw==true){
        const u32 px=x*CellSize,py=y*CellSize;
        CglB15 *pB15=NULL;
        CglTGF *pTGF=NULL;
        switch(pCell->Check){
          case ECC_Frame: {
            u32 sx=CellSize,sy=CellSize;
            if(x==0) sx*=0;
            if(x==(CellsWidth-1)) sx*=2;
            if(y==0) sy*=0;
            if(y==(CellsHeight-1)) sy*=2;
            pci->pFrame->BitBlt(pcan,PadX+px,PadY+py,CellSize,CellSize,sx,sy);
          } break;
          case ECC_None: {
            if(pCell->isPreview==true){
              pTGF=pci->pHint[0];
              }else{
              if(pCell->isOpened==false){
                pB15=pci->pClose;
                }else{
                if(pCell->isBomb==true){
                  pTGF=pci->pBomb;
                  }else{
                  pTGF=pci->pHint[pCell->Hint];
                }
              }
            }
          } break;
          case ECC_Flag: {
            pB15=pci->pFlag;
          } break;
          case ECC_Mark: {
            pB15=pci->pMark;
          } break;
        }
        if(pB15!=NULL){
          pB15->BitBlt(pcan,PadX+px,PadY+py,CellSize,CellSize,0,0);
        }
        if(pTGF!=NULL){
          if(isTop==true){
            pTopBG->BitBlt(pcan,PadX+px,PadY+py,CellSize,CellSize,PadX+px,PadY+py);
            }else{
            CglB15 *pb15=pci->pBG;
            pb15->BitBlt(pcan,PadX+px,PadY+py,CellSize,CellSize,(PadX+px)%pb15->GetWidth(),(PadY+py)%pb15->GetHeight());
          }
          pTGF->BitBlt(pcan,PadX+px,PadY+py);
        }
      }
    }
  }
}

void MS_ExclusiveRefresh(void)
{
  TCell *pCell=GetCellFromPos(0,0);
  pCell->ReqDraw=true;
}

bool MS_Refresh(void)
{
  if(pTopBM!=NULL) MS_Refresh_ins(pTopBM,&CellImgsTop,true);
  if(pBtmBM!=NULL) MS_Refresh_ins(pBtmBM,&CellImgsBtm,false);
  
  bool Refreshed=false;
  
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if(pCell->ReqDraw==true){
        pCell->ReqDraw=false;
        Refreshed=true;
      }
    }
  }
  
  return(Refreshed);
}

// -----------------------------------------------

void MS_Draw_Top_ins_DrawBox(CglCanvas *pcan,u32 x,u32 y,u32 w,u32 h)
{
  u16 *pbuf=pcan->GetScanLine(y);
  pbuf+=x;
  const u32 addsize=ScreenWidth-w;
#define FFill(src) (((src&0x739C)>>2)+RGB15(24,16,16)|BIT15)
#define BFill(src) (((src&0x7BDE)>>1)+RGB15(12,8,8)|BIT15)
#define SFill(src) (((src&0x7BDE)>>1)+RGB15(4,4,4)|BIT15)
  {
    for(u32 px=0;px<w-1;px++){
      *pbuf++=FFill(*pbuf);
    }
    *pbuf++;
    pbuf+=addsize;
  }
  for(u32 py=1;py<h-1-1;py++){
    *pbuf++=FFill(*pbuf);
    for(u32 px=1;px<w-1-1;px++){
      *pbuf++=BFill(*pbuf);
    }
    *pbuf++=FFill(*pbuf);
    *pbuf++=SFill(*pbuf);
    pbuf+=addsize;
  }
  {
    for(u32 px=0;px<w-1;px++){
      *pbuf++=FFill(*pbuf);
    }
    *pbuf++=SFill(*pbuf);
    pbuf+=addsize;
  }
  {
    *pbuf++=FFill(*pbuf);
    for(u32 px=1;px<w;px++){
      *pbuf++=SFill(*pbuf);
    }
  }
#undef FFill
#undef BFill
#undef SFill
}

static u32 InfoBarPos=0;

void MS_Draw_Top(CglCanvas *pcan,bool DrawFrame)
{
  if(pTopBM==NULL) return;
  
  CglCanvas *ptmpcan=new CglCanvas(&MM_Temp,NULL,ScreenWidth,ScreenHeight,pf15bit);
  
  pTopBM->BitBltFullBeta(ptmpcan);
  
  if(DrawFrame==true){
    const s32 CellSize=CellSizeTop;
    const s32 CanvasWidth=ptmpcan->GetWidth(),CanvasHeight=ptmpcan->GetHeight();
    const s32 PadX=(CanvasWidth-(CellsWidth*CellSize))/2;
    const s32 PadY=(CanvasHeight-(CellsHeight*CellSize))/2;
    
    const s32 InfoBarHeight=32;
    
    const float m=(float)CellSize/CellSizeBtm;
    if(1<=m){
      InfoBarPos=1;
      }else{
      s32 x=PadX+(ScrPos.x*m),y=PadY+(ScrPos.y*m);
      const s32 w=ScreenWidth*m,h=ScreenHeight*m;
      
      if(x<0) x=0;
      if((CanvasWidth-w-1)<x) x=CanvasWidth-w-1;
      if(y<0) y=0;
      if((CanvasHeight-h-1)<y) y=CanvasHeight-h-1;
      
      MS_Draw_Top_ins_DrawBox(ptmpcan,x,y,w,h);
      
      if((ScreenHeight-(InfoBarHeight*2))<h){
        InfoBarPos=1;
        }else{
        if(InfoBarPos==0){
          if(y<InfoBarHeight) InfoBarPos=1;
          }else{
          if((ScreenHeight-InfoBarHeight)<(y+h)) InfoBarPos=0;
        }
      }
    }
    
    u32 InfoBarY,TextY;
    if(InfoBarPos==0){
      InfoBarY=0;
      TextY=0;
      pInfoBarTGF->BitBltLimitY(ptmpcan,0,InfoBarY,InfoBarHeight,InfoBarY);
      }else{
      InfoBarY=ScreenHeight-InfoBarHeight;
      TextY=ScreenHeight-16;
      pInfoBarTGF->BitBltLimitY(ptmpcan,0,InfoBarY,InfoBarHeight,InfoBarY);
    }
    
    ptmpcan->SetCglFont(pCglFontDefault);
    ptmpcan->SetFontTextColor(RGB15(0,0,0)|BIT15);
    char msg[256];
    if(Level==0){
      snprintf(msg,256,"(%dx%d) %d/%d Time:%d",CellsWidth-2,CellsHeight-2,RemainFlagsCount,BombsCount,ElapsedTime/60);
      }else{
      snprintf(msg,256,"Lv.%d Bombs:%d/%d Time:%d",Level,RemainFlagsCount,BombsCount,ElapsedTime/60);
    }
    ptmpcan->TextOutUTF8(2,TextY+2,msg);
  }
  
  ptmpcan->BitBltFullBeta(pcan);
  if(ptmpcan!=NULL){
    delete ptmpcan; ptmpcan=NULL;
  }
}

void MS_Draw_Btm(CglCanvas *pcan)
{
  if(pBtmBM==NULL) return;
  
  s32 srcx=ScrPos.x,srcy=ScrPos.y;
  s32 ofsx=0,ofsy=0;
  s32 w=ScreenWidth,h=ScreenHeight;
  
  bool DrawBG=false;
  
  if(srcx<0){
    DrawBG=true;
    ofsx=-srcx;
    srcx=0;
    w-=ofsx;
  }
  if(srcy<0){
    DrawBG=true;
    ofsy=-srcy;
    srcy=0;
    h-=ofsy;
  }
  
  if(pBtmBM->GetWidth()<(srcx+w)) DrawBG=true;
  if(pBtmBM->GetHeight()<(srcy+h)) DrawBG=true;
  
  if(DrawBG==true) pTopBG->pCanvas->BitBltFullBeta(pcan);
  
  pBtmBM->BitBlt(pcan,ofsx,ofsy,w,h,srcx,srcy,false);
}

// -----------------------------------------------

TPoint MS_GetCellIndexFromScreenView(s32 curx,s32 cury)
{
  s32 CellSize=CellSizeBtm;
  if(CellSize==0) CellSize=1;
  
  curx=(ScrPos.x+curx)/CellSize;
  cury=(ScrPos.y+cury)/CellSize;
  
  TPoint res={curx,cury};
  return(res);
}

// -----------------------------------------------

void MS_OpenCell(s32 curx,s32 cury)
{
  if(GameMode!=EGM_Play) return;
  
  if(InsideCellFromPos(curx,cury)==false) return;
  
  {
    TCell *pCell=GetCellFromPos(curx,cury);
    if(pCell->Check!=ECC_None) return;
  }
  
  SetupBomb(curx,cury);
  
  SetAutoOpenFlagFromPos(curx,cury,0);
  
  TCell *pCell=GetCellFromPos(curx,cury);
  if(pCell->isOpened==true) return;
  
  pCell->ReqDraw=true;
  pCell->isOpened=true;
  
  if(pCell->isBomb==true){
    GameMode=EGM_GameOver;
    const s32 CellSize=CellSizeBtm;
    Particle_SetFireBomb((curx*CellSize)+(CellSize/2)-ScrPos.x,(cury*CellSize)+(CellSize/2)-ScrPos.y);
    u32 CheckedBomb=0;
    for(u32 y=0;y<CellsHeight;y++){
      for(u32 x=0;x<CellsWidth;x++){
        TCell *pCell=GetCellFromPos(x,y);
        if(pCell->isBomb==true){
          if(pCell->Check==ECC_Flag) CheckedBomb++;
          pCell->Check=ECC_None;
          pCell->ReqDraw=true;
          pCell->isOpened=true;
        }
      }
    }
    RestBomb=BombsCount-CheckedBomb;
    return;
  }
  
  StartSE(WAVFN_Open);
  
  Cells_AutoOpen((TPoint){curx,cury});
}

void MS_ChangeCheck(s32 curx,s32 cury)
{
  if(GameMode!=EGM_Play) return;
  
  if(GetBombsSetupped()==false) return;
  
  if(InsideCellFromPos(curx,cury)==false) return;
  
  TCell *pCell=GetCellFromPos(curx,cury);
  if(pCell->isOpened==true) return;
  if(pCell->Check==ECC_Frame) return;
  
  StartSE(WAVFN_Change);
  
  pCell->ReqDraw=true;
  
  // Unlink now.
  switch(pCell->Check){
    case ECC_None: {
    } break;
    case ECC_Flag: {
      RemainFlagsCount++;
      if(pCell->isBomb==true) HitBombsCount--;
      if((RemainFlagsCount==0)&&(HitBombsCount==BombsCount)){
        GameMode=EGM_Clear;
      }
    } break;
    case ECC_Mark: {
    } break;
  }
  
  // Change state.
  switch(pCell->Check){
    case ECC_None: pCell->Check=ECC_Flag; break;
    case ECC_Flag: {
      if(ProcState.Main.UseQuestionMark==true){
        pCell->Check=ECC_Mark;
        }else{
        pCell->Check=ECC_None;
      }
    } break;
    case ECC_Mark: pCell->Check=ECC_None; break;
  }
  
  // Link now.
  switch(pCell->Check){
    case ECC_None: {
    } break;
    case ECC_Flag: {
      pCell->Check=ECC_None;
      MS_SetFlag(curx,cury);
    } break;
    case ECC_Mark: {
    } break;
  }
}

static void MS_SetFlag(s32 x,s32 y)
{
  TCell *pCell=GetCellFromPos(x,y);
  if((pCell->isOpened==true)||(pCell->Check!=ECC_None)){
    _consolePrintf("MS_SetFlag: Internal error. %d,%d %d,%d\n",x,y,pCell->isOpened,pCell->Check);
    while(1);
  }
  
  pCell->ReqDraw=true;
  pCell->Check=ECC_Flag;
  
  {
    RemainFlagsCount--;
    if(pCell->isBomb==true) HitBombsCount++;
    if((RemainFlagsCount==0)&&(HitBombsCount==BombsCount)){
      GameMode=EGM_Clear;
      return;
    }
  }
}

// -----------------------------------------------

void MS_SetPreview(s32 curx,s32 cury)
{
  if(GameMode!=EGM_Play) return;
  
  if(InsideCellFromPos(curx,cury)==false) return;
  
  TCell *pCell=GetCellFromPos(curx,cury);
  if(pCell->isOpened==false){
    pCell->ReqDraw=true;
    pCell->isPreview=true;
  }
}

void MS_UnsetPreview(void)
{
  if(GameMode!=EGM_Play) return;
  
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if(pCell->isPreview==true){
        pCell->ReqDraw=true;
        pCell->isPreview=false;
      }
    }
  }
}

// -----------------------------------------------

u32 MS_GetBottomCellSize(void)
{
  return(CellSizeBtm);
}

TPoint MS_GetScroll(void)
{
  return(ScrPos);
}

void MS_SetScroll(TPoint Vector)
{
  ScrPos=Vector;
}

TPoint MS_InsideScreen(TPoint Vector)
{
  if(pBtmBM==NULL) StopFatalError(0,"pBtmBM is NULL!");
  
  const TPoint Limit={pBtmBM->GetWidth()-ScreenWidth,pBtmBM->GetHeight()-ScreenHeight};
  
  const s32 cs=CellSizeBtm;
  
  if(-cs<(Limit.x+cs)){
    if(Vector.x<-cs) Vector.x=-cs;
    if((Limit.x+cs)<Vector.x) Vector.x=Limit.x+cs;
    }else{
    Vector.x=(pBtmBM->GetWidth()-ScreenWidth)/2;
  }
  if(-cs<(Limit.y+cs)){
    if(Vector.y<-cs) Vector.y=-cs;
    if((Limit.y+cs)<Vector.y) Vector.y=Limit.y+cs;
    }else{
    Vector.y=(pBtmBM->GetHeight()-ScreenHeight)/2;
  }
  
  return(Vector);
}

// -----------------------------------------------

void MS_BtmScrZoom(void)
{
  s32 CellSize=CellSizeBtm;
  CellSize+=4;
  if(CellSize==28) CellSize+=4;
  if(MS_CellMaxSize<CellSize) return;
    
  ChangeCellSizeBtm(CellSize);
}

void MS_BtmScrReduce(void)
{
  s32 CellSize=CellSizeBtm;
  CellSize-=4;
  if(CellSize==28) CellSize-=4;
  if(CellSize<MS_CellMinSize) return;
  
  ChangeCellSizeBtm(CellSize);
}

// -----------------------------------------------

void MS_ShowAllBombs(void)
{
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if(pCell->isBomb==true){
        pCell->Check=ECC_None;
        pCell->ReqDraw=true;
        pCell->isOpened=true;
      }
    }
  }
}

bool MS_GetBombsSetupped(void)
{
  return(BombsSetupped);
}

// -----------------------------------------------

bool MS_TitleDemo(void)
{
  u32 cnt=0;
  
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if((pCell->isBomb==false)&&(pCell->isOpened==false)&&(pCell->Check==ECC_None)) cnt++;
    }
  }
  
  if(cnt==0) return(false);
  
  u32 idx=rand(cnt);
  
  for(u32 y=0;y<CellsHeight;y++){
    for(u32 x=0;x<CellsWidth;x++){
      TCell *pCell=GetCellFromPos(x,y);
      if((pCell->isBomb==false)&&(pCell->isOpened==false)&&(pCell->Check==ECC_None)){
        if(idx==0){
          MS_OpenCell(x,y);
          return(true);
        }
        idx--;
      }
    }
  }
  
  StopFatalError(0,"Search open cell error.");
  return(false);
}

u32 MS_GetElapsedTimeTime(void)
{
  return(ElapsedTime);
}

u32 MS_GetRestBomb(void)
{
  return(RestBomb);
}

u32 MS_GetRemainFlagsCount(void)
{
  return(RemainFlagsCount);
}

