#pragma once

// Inport from...
// ---------------------------
// MineSweeper for Windows CUI
// Author:Imoimo
// Maked At:2010/08/29
// ---------------------------

#define MS_CellMaxSize (32)
#define MS_CellMinSize (8)
#define MS_CellsMinWidth ((ScreenWidth+(MS_CellMaxSize-1))/MS_CellMaxSize-1)
#define MS_CellsMinHeight ((ScreenHeight+(MS_CellMaxSize-1))/MS_CellMaxSize-1)
#define MS_CellsMaxWidth (ScreenWidth/MS_CellMinSize)
#define MS_CellsMaxHeight (ScreenHeight/MS_CellMinSize)

enum EGameMode {EGM_Play,EGM_Clear,EGM_GameOver,EGM_Interrupt};

extern void MS_Init(u32 _Level,s32 _CellsWidth,s32 _CellsHeight,u32 _BombsCount,bool GameMain,u32 _CellSizeBtm);
extern void MS_Free(void);

extern void MS_Interrupt(void);

extern void MS_VsyncInterrupt(u32 VsyncCount);

extern void MS_SetupDemo(void);
extern void MS_SetEnableSE(bool _EnableSE);

extern u32 MS_GetCellsWidth(void);
extern u32 MS_GetCellsHeight(void);

extern EGameMode MS_GetGameMode(void);

extern bool MS_ProcessAutoOpen(void);

extern void MS_ExclusiveRefresh(void);

extern bool MS_Refresh(void);
extern void MS_Draw_Top(CglCanvas *pcan,bool DrawFrame);
extern void MS_Draw_Btm(CglCanvas *pcan);

extern TPoint MS_GetCellIndexFromScreenView(s32 curx,s32 cury);

extern void MS_OpenCell(s32 curx,s32 cury);
extern void MS_ChangeCheck(s32 curx,s32 cury);

extern void MS_SetPreview(s32 curx,s32 cury);
extern void MS_UnsetPreview(void);

extern u32 MS_GetBottomCellSize(void);

extern TPoint MS_GetScroll(void);
extern void MS_SetScroll(TPoint Vector);

extern TPoint MS_InsideScreen(TPoint Vector);

extern void MS_BtmScrZoom(void);
extern void MS_BtmScrReduce(void);

extern void MS_ShowAllBombs(void);

extern bool MS_GetBombsSetupped(void);

extern bool MS_TitleDemo(void);

extern u32 MS_GetElapsedTimeTime(void);

extern u32 MS_GetRestBomb(void);
extern u32 MS_GetRemainFlagsCount(void);
