#pragma once

#include "rect.h"

extern void NumBox_Init(void);
extern void NumBox_Free(void);
extern CglTGF* NumBox_GetFont(void);

class CNumBox
{
private:
  const u32 Digits;
  const CglTGF *pOpenBG;
  const TRect OpenBGRect;
  const CglTGF *pClosedBG;
  const TRect ClosedBGRect;
  const CglTGF *pFont;
  const s32 FontWidth,FontHeight;
  const CglTGF *pOKBtn;
  const s32 PosLeft,PosTop;
  
  bool Enabled;
  CglCanvas *pWindowBG;
  s32 Min,Max;
  float CurY,TagY;
  bool mf;
  s32 mx,my;
  u32 mv;
  
  typedef struct {
    u32 mx,my,mv;
  } TMouseLog;
  TMouseLog MouseLogs[3];
  
  CNumBox(const CNumBox&);
  CNumBox& operator=(const CNumBox&);
  bool NumClosedBG_isInside(s32 x,s32 y);
  void Disabled(void);
  void StoreMouseLog(u32 mx,u32 my,u32 mv);
protected:
public:
  CNumBox(const u32 _Digits,const s32 _PosLeft,const s32 _PosTop,const u32 DefaultNum);
  ~CNumBox(void);
  
  void SetLimit(s32 _Min,s32 _Max);
  void SetCurrentNumber(s32 num);
  s32 GetCurrentNumber(void);
  
  bool CB_MouseDown(s32 x,s32 y);
  void CB_MouseMove(s32 x,s32 y);
  void CB_MouseUp(s32 x,s32 y);
  
  void VsyncUpdate(u32 VsyncCount);
  bool GetEnabled(void);
  void Draw(CglCanvas *pcan);
};

