
bool TitleShowHighScoreMsgBox=false;

enum EBtnFunc {EBF_None,EBF_Lv1,EBF_Lv2,EBF_Lv3,EBF_Lv4,EBF_Lv5,EBF_HighScore,EBF_HighScoreMsgBox,EBF_Setup,EBF_Custom,EBF_Help,EBF_HelpMsgBox,EBF_CustomBack,EBF_CustomStart};

typedef struct {
  CglTGF *ptgf;
  u32 x,y,w,h;
  EBtnFunc Func;
} TBtn;
static TBtn Btns[16];
static u32 BtnsCount;

static void Btns_Init(void)
{
  BtnsCount=0;
}

static void Btns_Free(void)
{
  for(u32 idx=0;idx<BtnsCount;idx++){
    TBtn *pBtn=&Btns[idx];
    if(pBtn->ptgf!=NULL){
      delete pBtn->ptgf; pBtn->ptgf=NULL;
    }
  }
}

static TBtn Btns_Setup_ins_SetInfo(EBtnFunc BtnFunc)
{
  TBtn Btn;
  
  ESkinFiles sf;
  
  switch(BtnFunc){
    case EBF_None: StopFatalError(0,"Illigal btn func. (%d)",BtnFunc); break;
    case EBF_Lv1: sf=ESF_LevelSelect_Buttons_Lv1_tgf; break;
    case EBF_Lv2: sf=ESF_LevelSelect_Buttons_Lv2_tgf; break;
    case EBF_Lv3: sf=ESF_LevelSelect_Buttons_Lv3_tgf; break;
    case EBF_Lv4: sf=ESF_LevelSelect_Buttons_Lv4_tgf; break;
    case EBF_Lv5: sf=ESF_LevelSelect_Buttons_Lv5_tgf; break;
    case EBF_HighScore: sf=ESF_LevelSelect_Buttons_HighScore_tgf; break;
    case EBF_HighScoreMsgBox: sf=ESF_LevelSelect_Buttons_HighScoreMsgBox_tgf; break;
    case EBF_Setup: sf=ESF_LevelSelect_Buttons_Setup_tgf; break;
    case EBF_Custom: sf=ESF_LevelSelect_Buttons_Custom_tgf; break;
    case EBF_Help: sf=ESF_LevelSelect_Buttons_Help_tgf; break;
    case EBF_HelpMsgBox: sf=ESF_LevelSelect_Buttons_HelpMsgBox_tgf; break;
    case EBF_CustomBack: sf=ESF_Custom_Buttons_Back_tgf; break;
    case EBF_CustomStart: sf=ESF_Custom_Buttons_Start_tgf; break;
    default: StopFatalError(0,"Illigal btn func. (%d)",BtnFunc); break;
  }
  
  Btn.ptgf=SkinPack_LoadTGF(sf);
  Btn.x=0;
  Btn.y=0;
  Btn.w=Btn.ptgf->GetWidth();
  Btn.h=Btn.ptgf->GetHeight();
  Btn.Func=BtnFunc;
  
  return(Btn);
}

static void Btns_Setup(void)
{
  Btns_Free();
  
  BtnsCount=0;
  
  switch(Page){
    case EP_Select: {
      if(ProcState.Score.ClearCount[4]==0) Btns[BtnsCount++]=Btns_Setup_ins_SetInfo(EBF_Lv1);
      if(ProcState.Score.ClearCount[1]!=0) Btns[BtnsCount++]=Btns_Setup_ins_SetInfo(EBF_Lv2);
      if(ProcState.Score.ClearCount[2]!=0) Btns[BtnsCount++]=Btns_Setup_ins_SetInfo(EBF_Lv3);
      if(ProcState.Score.ClearCount[3]!=0) Btns[BtnsCount++]=Btns_Setup_ins_SetInfo(EBF_Lv4);
      if(ProcState.Score.ClearCount[4]!=0) Btns[BtnsCount++]=Btns_Setup_ins_SetInfo(EBF_Lv5);
      const u32 w=104,h=40;
      const u32 padx=16,pady=24;
      switch(BtnsCount){
        case 0: StopFatalError(0,"Btns setup error. BtnsCount=%d.",BtnsCount); break;
        case 1: {
          const u32 xc=(ScreenWidth-w)/2,yc=(ScreenHeight-h)/2;
          Btns[0].x=xc; Btns[0].y=yc;
        } break;
        case 2: {
          const u32 x1=(ScreenWidth/2)-(padx/2)-w;
          const u32 x2=(ScreenWidth/2)+(padx/2);
          const u32 yc=(ScreenHeight-h)/2;
          Btns[0].x=x1; Btns[0].y=yc;
          Btns[1].x=x2; Btns[1].y=yc;
        } break;
        case 3: {
          const u32 xc=(ScreenWidth-w)/2;
          const u32 x1=(ScreenWidth/2)-(padx/2)-w;
          const u32 x2=(ScreenWidth/2)+(padx/2);
          const u32 y1=(ScreenHeight/2)-(pady/2)-h;
          const u32 y2=(ScreenHeight/2)+(pady/2);
          Btns[0].x=x1; Btns[0].y=y1;
          Btns[1].x=x2; Btns[1].y=y1;
          Btns[2].x=xc; Btns[2].y=y2;
        } break;
        case 4: {
          const u32 x1=(ScreenWidth/2)-(padx/2)-w;
          const u32 x2=(ScreenWidth/2)+(padx/2);
          const u32 y1=(ScreenHeight/2)-(pady/2)-h;
          const u32 y2=(ScreenHeight/2)+(pady/2);
          Btns[0].x=x1; Btns[0].y=y1;
          Btns[1].x=x2; Btns[1].y=y1;
          Btns[2].x=x1; Btns[2].y=y2;
          Btns[3].x=x2; Btns[3].y=y2;
        } break;
        default: StopFatalError(0,"Btns setup error. BtnsCount=%d.",BtnsCount); break;
      }
      if(ProcState.Score.PlayCount[1]!=0){
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_HighScore);
        Btn.x=0;
        Btn.y=0;
        Btns[BtnsCount++]=Btn;
      }
      if(TitleShowHighScoreMsgBox==true){
        TitleShowHighScoreMsgBox=false;
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_HighScoreMsgBox);
        Btn.x=2;
        Btn.y=32+4;
        Btns[BtnsCount++]=Btn;
      }
      {
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_Setup);
        Btn.x=ScreenWidth-Btn.w;
        Btn.y=0;
        Btns[BtnsCount++]=Btn;
      }
      bool ShowCustom=false;
      if(ProcState.Score.ClearCount[2]!=0) ShowCustom=true;
      if(ShowCustom==true){
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_Custom);
        Btn.x=0;
        Btn.y=ScreenHeight-Btn.h;
        Btns[BtnsCount++]=Btn;
      }
      {
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_Help);
        Btn.x=ScreenWidth-Btn.w;
        Btn.y=ScreenHeight-Btn.h;
        if(ShowCustom==false){
          Btn.x-=8;
          Btn.y-=8;
        }
        Btns[BtnsCount++]=Btn;
      }
      if(ProcState.System.FirstStart==true){
        ProcState.System.FirstStart=false;
        static bool First=true;
        if(First==true){
          First=false;
          TBtn Btn=Btns_Setup_ins_SetInfo(EBF_HelpMsgBox);
          Btn.x=(ScreenWidth-Btn.w)/2;
          Btn.y=ScreenHeight-8-Btn.h;
          Btns[BtnsCount++]=Btn;
        }
      }
    } break;
    case EP_Custom: {
      {
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_CustomBack);
        Btn.x=ScreenWidth-Btn.w;
        Btn.y=0;
        Btns[BtnsCount++]=Btn;
      }
      {
        TBtn Btn=Btns_Setup_ins_SetInfo(EBF_CustomStart);
        Btn.x=0;
        Btn.y=ScreenHeight-Btn.h;
        Btns[BtnsCount++]=Btn;
      }
    } break;
  }
}

static EBtnFunc Btns_GetFunc(u32 x,u32 y)
{
  EBtnFunc EBF=EBF_None;
  
  for(u32 idx=0;idx<BtnsCount;idx++){
    TBtn *pBtn=&Btns[idx];
    if((pBtn->x<=x)&&(x<(pBtn->x+pBtn->w))&&(pBtn->y<=y)&&(y<(pBtn->y+pBtn->h))) EBF=pBtn->Func;
  }
  
  return(EBF);
}

static void Btns_Draw(CglCanvas *pcan)
{
  for(u32 idx=0;idx<BtnsCount;idx++){
    TBtn *pBtn=&Btns[idx];
    u32 x=pBtn->x,y=pBtn->y;
    if(pBtn->Func==EBF_HighScoreMsgBox){
      static float r=0;
      r+=0.075;
      float v=sin(r)*4;
      if(v<0) v=-v;
      y+=v;
    }
    if(pBtn->Func==EBF_HelpMsgBox){
      static float r=0;
      r+=0.075;
      float v=sin(r)*4;
      if(v<0) v=-v;
      x+=v;
    }
    pBtn->ptgf->BitBlt(pcan,x,y);
  }
}

static void Btns_Execute(EBtnFunc BtnFunc)
{
  switch(BtnFunc){
    case EBF_None: break;
    case EBF_Lv1: case EBF_Lv2: case EBF_Lv3: case EBF_Lv4: case EBF_Lv5: {
      u32 SelectedLevel;
      switch(BtnFunc){
        default: StopFatalError(0,"Illigal btn func. (%d!=EBF_Lv?)",BtnFunc); break;
        case EBF_Lv1: SelectedLevel=1; break;
        case EBF_Lv2: SelectedLevel=2; break;
        case EBF_Lv3: SelectedLevel=3; break;
        case EBF_Lv4: SelectedLevel=4; break;
        case EBF_Lv5: SelectedLevel=5; break;
      }
      SoundSE_Start(WAVFN_GameStart);
      DrawSelectedBottomScreen(SelectedLevel);
      SetProcFadeEffect(EPFE_CrossFade);
      ScreenMain_Flip_ProcFadeEffect();
      ProcState.Main.PlayLevel=SelectedLevel;
      ProcState_RequestSave=true;
      SetNextProc(ENP_Main,EPFE_CrossFade);
    } break;
    case EBF_HighScore: case EBF_HighScoreMsgBox: {
      ProcState.Main.TitleShowHighScore=!ProcState.Main.TitleShowHighScore;
      if(ProcState.Main.TitleShowHighScore==true) SoundSE_Start(WAVFN_HighScore);
      ProcState_RequestSave=true;
      DrawTopScreen();
    } break;
    case EBF_Setup: {
      ProcState.Main.PlayLevel=1;
      ProcState_RequestSave=true;
      SoundSE_Start(WAVFN_Setting);
      SetNextProc(ENP_Settings,EPFE_RightToLeft);
    } break;
    case EBF_Custom: {
      SoundSE_Start(WAVFN_ClickButton);
      Page=EP_Custom;
      Btns_Setup();
      SetProcFadeEffect(EPFE_CrossFade);
      MSHelp_Init();
      DrawTopScreen();
    } break;
    case EBF_Help: case EBF_HelpMsgBox: {
      SoundSE_Start(WAVFN_ClickButton);
      SetNextProc(ENP_Help,EPFE_CrossFade);
    } break;
    case EBF_CustomBack: {
      SoundSE_Start(WAVFN_ClickButton);
      Page=EP_Select;
      Btns_Setup();
      SetProcFadeEffect(EPFE_CrossFade);
      MSHelp_Init();
      DrawTopScreen();
    } break;
    case EBF_CustomStart: {
      SoundSE_Start(WAVFN_GameStart);
      ProcState.Main.PlayLevel=0;
      ProcState_RequestSave=true;
      SetNextProc(ENP_Main,EPFE_CrossFade);
    } break;
    default: StopFatalError(0,"Illigal btn func. (%d)",BtnFunc); break;
  }
}


