
static CglTGF *pButtons_Title;

static void Select_Init(void)
{
  pButtons_Title=SkinPack_LoadTGF(ESF_LevelSelect_Buttons_Title_tgf);
}

static void Select_Free(void)
{
  if(pButtons_Title!=NULL){
    delete pButtons_Title; pButtons_Title=NULL;
  }
}

static void Select_DrawTopScreen(CglCanvas *pcan)
{
#define NFill(pbuf) { \
  pbuf++; \
}

#define BFill(pbuf) { \
  u32 col=*pbuf; \
  col=(col&0x7BDE7BDE)>>1; \
  const u32 b=15; \
  col+=RGB15(b+1,b,b)|(RGB15(b+1,b,b)<<16)|BIT15|BIT31; \
  *pbuf++=col; \
}

#define IFill(pbuf) { \
  u32 col=*pbuf; \
  col=(col&0x739C739C)>>2; \
  const u32 b=20; \
  col+=RGB15(b+2,b,b)|(RGB15(b+2,b,b)<<16)|BIT15|BIT31; \
  *pbuf++=col; \
}

  u32 *pbuf=(u32*)pcan->GetVRAMBuf();
  
  for(u32 y=0;y<16;y++){
    for(u32 x=0/2;x<ScreenWidth/2;x++) NFill(pbuf);
  }
  
  for(u32 y=16;y<ScreenHeight-16;y++){
    for(u32 x=0/2;x<16/2;x++) NFill(pbuf);
    for(u32 x=16/2;x<(ScreenWidth-15)/2;x++) IFill(pbuf);
    for(u32 x=(ScreenWidth-15)/2;x<ScreenWidth/2;x++) NFill(pbuf);
  }
  
  for(u32 y=ScreenHeight-16;y<ScreenHeight;y++){
    for(u32 x=0/2;x<ScreenWidth/2;x++) NFill(pbuf);
  }
  
  pTitleTop->BitBlt(pcan,0,0);
}

static void Select_DrawBottomScreen(CglCanvas *pcan)
{
  pButtons_Title->BitBlt(pcan,0,0);
}

static void Select_DrawSelectedBottomScreen(u32 SelectedLevel,CglCanvas *pcan)
{
  pButtons_Title->BitBlt(pcan,0,0);
  
  if(SelectedLevel==0) StopFatalError(0,"Level == 0");
  
  EBtnFunc EBF=EBF_None;
  
  switch(SelectedLevel){
    default: EBF=EBF_Lv1; break;
    case 1: EBF=EBF_Lv1; break;
    case 2: EBF=EBF_Lv2; break;
    case 3: EBF=EBF_Lv3; break;
    case 4: EBF=EBF_Lv4; break;
    case 5: EBF=EBF_Lv5; break;
  }
  
  for(u32 idx=0;idx<BtnsCount;idx++){
    TBtn *pBtn=&Btns[idx];
    if(pBtn->Func==EBF) pBtn->ptgf->BitBlt(pcan,pBtn->x,pBtn->y);
  }
}

static void Select_CB_KeyPress(u32 VsyncCount,u32 Keys,bool FirstFlag)
{
  if(Keys&(KEY_START|KEY_A)){
    EBtnFunc EBF=EBF_None;
    switch(ProcState.Main.PlayLevel){
      default: EBF=EBF_Lv1; break;
      case 1: EBF=EBF_Lv1; break;
      case 2: EBF=EBF_Lv2; break;
      case 3: EBF=EBF_Lv3; break;
      case 4: EBF=EBF_Lv4; break;
      case 5: EBF=EBF_Lv5; break;
    }
    Btns_Execute(EBF);
  }
  
  if(Keys&KEY_SELECT){
    Btns_Execute(EBF_Setup);
  }
}

